#!/usr/bin/env python
# -*- coding: utf-8 -*-

from gimpfu import *

import sys
import os
import glob
import re

def log(a):
	pdb.gimp_message(a)	

	
def python_pedipal(image, layer, fixed_palette, empty_color):
	
	fixed_colors_n, fixed_colors_list = pdb.gimp_palette_get_colors(fixed_palette)

	fixed_colors = []
	
	free_colors = 0
	for i, color in enumerate(fixed_colors_list):
		if(color == empty_color):
			free_colors = free_colors + 1
		else:
			fixed_colors.append((i, color))
	
	if image.base_type == INDEXED:
		pdb.gimp_image_convert_rgb(image)
	
	pdb.gimp_image_convert_indexed(image, NO_DITHER, MAKE_PALETTE, free_colors, FALSE, FALSE, "")
	
	short_colormap_n, short_colormap = pdb.gimp_image_get_colormap(image)
	
	palette = pdb.gimp_palette_duplicate(fixed_palette)
	
	fro = 0
	for to in range(0,256):
		fixed_color = fixed_colors_list[to]
		if fixed_color == empty_color:
			pdb.gimp_palette_entry_set_color(
				palette, 
				to, 
				gimpcolor.RGB(short_colormap[fro], short_colormap[fro+1], short_colormap[fro+2])
			)			
			if fro < len(short_colormap) - 3:
				fro = fro + 3
			
			
	pdb.gimp_image_convert_rgb(image)
	pdb.gimp_image_convert_indexed(image, NO_DITHER, CUSTOM_PALETTE, 255, FALSE, FALSE, palette)
	pdb.gimp_palette_delete(palette)

register(
	"python-fu-pedipal",
	"Converts image palette to one compatible with OpenXCOM Pedia",
	"You should provide a palette where fixed colors are on right places, and other colors are filled with color #B00B15",
	"Alexander Petrov",
	"Alexander Petrov (baturinsky@gmail.com)",
	"2017",
	"<Image>/Image/Make Pedia-compatible",
	"*",
	[
		(PF_PALETTE , "palette", "Reference palette", "XCOM-Ufopaedia-Fixed"),
		(PF_COLOR , "color", "Color of free slots in palette", gimpcolor.RGB(0xB0, 0x0B, 0x15))
	],
	[],
	python_pedipal
) 

main()